function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from "prop-types";
import { Step } from 'semantic-ui-react';
import { getRandomNumber } from "./static/ObjectsUtils";

var PublicStep = function (_Component) {
    _inherits(PublicStep, _Component);

    function PublicStep(props) {
        _classCallCheck(this, PublicStep);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.triggerStepChanges = function (currentStep) {
            var stepOptions = _this.state.stepOptions;

            for (var i = 0; i < stepOptions.length; i++) {
                //stepOptions[i].onClick = this.onStepClick
                stepOptions[i].completed = false;
                stepOptions[i].active = false;
                stepOptions[i].disabled = true;
                if (i < currentStep) {
                    stepOptions[i].active = false;
                    stepOptions[i].completed = true;
                    stepOptions[i].disabled = false;
                } else if (currentStep === i) {
                    stepOptions[i].active = true;
                    stepOptions[i].completed = false;
                    stepOptions[i].disabled = false;
                } else if (i < currentStep) {
                    stepOptions[i].active = false;
                    stepOptions[i].completed = false;
                    stepOptions[i].disabled = true;
                }
            }
        };

        _this.state = {
            stepOptions: props.stepOptions,
            currentStep: props.currentStep === undefined ? 0 : parseInt(props.currentStep, 10),
            stepSize: props.stepSize === undefined ? 'small' : props.stepSize,
            divKey: getRandomNumber()
        };

        return _this;
    }

    PublicStep.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
        var _props = this.props,
            currentStep = _props.currentStep,
            stepOptions = _props.stepOptions;


        if (currentStep !== prevProps.currentStep) {
            this.setState({
                currentStep: currentStep,
                divKey: getRandomNumber()
            });
            this.triggerStepChanges(currentStep);
        }

        if (stepOptions !== prevProps.stepOptions) {
            this.setState({
                stepOptions: stepOptions,
                divKey: getRandomNumber()
            });
        }
    };

    /*  onStepClick = (event,data) => {
          if(data){
              console.log(data);
              if(data.completed){
               }
          }
      }
    */
    PublicStep.prototype.render = function render() {
        var _state = this.state,
            stepSize = _state.stepSize,
            stepOptions = _state.stepOptions,
            divKey = _state.divKey;


        return React.createElement(Step.Group, {
            key: divKey,
            size: stepSize,
            items: stepOptions
        });
    };

    return PublicStep;
}(Component);

export { PublicStep as default };
PublicStep.propTypes = process.env.NODE_ENV !== "production" ? {
    stepOptions: PropTypes.array.isRequired,
    currentStep: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    stepSize: PropTypes.string

} : {};