var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { Pagination } from 'semantic-ui-react';
import PropTypes from "prop-types";
import { isStringEmpty } from "../static/ObjectsUtils";

/**
 * Pagination Component for tables
 *
 * @Author: Rocky Chen
 */
var TablePagination = (_temp = _class = function (_Component) {
    _inherits(TablePagination, _Component);

    function TablePagination(props) {
        _classCallCheck(this, TablePagination);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.handlePaginationChange = function (e, _ref) {
            var activePage = _ref.activePage;

            //console.log(activePage)
            _this.setState({ activePage: activePage });
            _this.props.getActivePages(activePage);
        };

        _this.state = {
            totalPages: props.totalPages,
            activePage: props.currentPage // always show page one by default
        };
        return _this;
    }

    TablePagination.prototype.render = function render() {
        var activePage = this.state.activePage;
        var _props = this.props,
            paginationProps = _props.paginationProps,
            totalPages = _props.totalPages;
        var boundaryRange = paginationProps.boundaryRange,
            ellipsisItem = paginationProps.ellipsisItem,
            size = paginationProps.size,
            firstItem = paginationProps.firstItem,
            lastItem = paginationProps.lastItem,
            nextItem = paginationProps.nextItem,
            pageItem = paginationProps.pageItem,
            prevItem = paginationProps.prevItem,
            siblingRange = paginationProps.siblingRange;

        //console.log(activePage)

        return React.createElement(Pagination, {
            className: "right floated",
            activePage: activePage,
            onPageChange: this.handlePaginationChange,
            totalPages: totalPages,
            boundaryRange: boundaryRange,
            size: size,
            ellipsisItem: ellipsisItem,
            firstItem: firstItem,
            lastItem: lastItem,
            nextItem: nextItem,
            pageItem: pageItem,
            prevItem: prevItem,
            siblingRange: siblingRange
        });
    };

    return TablePagination;
}(Component), _class.defaultProps = {
    paginationProps: {
        size: 'small' //mini,tiny,small,medium,large,big,huge,massive
    }
}, _temp);
export { TablePagination as default };
TablePagination.propTypes = process.env.NODE_ENV !== "production" ? {
    totalPages: PropTypes.number.isRequired,
    getActivePages: PropTypes.func.isRequired,
    currentPage: PropTypes.number,
    paginationProps: PropTypes.object
} : {};