'use strict';

exports.__esModule = true;
exports.NoPaginationUserFooter = exports.CustomizedFooter = exports.PaginationFooterSecondary = exports.PaginationFooter = undefined;

var _class3, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TablePagination = require('./TablePagination');

var _TablePagination2 = _interopRequireDefault(_TablePagination);

var _ObjectsUtils = require('../static/ObjectsUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//{key: 't', text: '1', value: '1'},
var pageOptions = [{ key: 's', text: '10', value: 10 }, { key: 'm', text: '20', value: 20 }, { key: 'l', text: '50', value: 50 }];

/**
 * pagination footer example:
 * using data count and page size to calculate the pagination bar
 *
 * @type {{ colCount: *, pageSize: *, handlePageClick: *, dataCount: *}}
 */

var PaginationFooter = exports.PaginationFooter = function (_Component) {
    _inherits(PaginationFooter, _Component);

    function PaginationFooter(props) {
        _classCallCheck(this, PaginationFooter);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.handlePageSizeChange = function (e, _ref) {
            var value = _ref.value;


            //Auto set page to page 1
            _this.props.handlePageClick(1);

            _this.setState({
                pageSize: value,
                footerKey: (0, _ObjectsUtils.getRandomNumber)()
            });

            _this.props.onPageSizeChange(value);
        };

        _this.state = {
            footerKey: (0, _ObjectsUtils.getRandomNumber)()
        };
        return _this;
    }

    PaginationFooter.prototype.handlePageClick = function handlePageClick(val) {
        this.props.handlePageClick(val);
    };

    PaginationFooter.prototype.render = function render() {
        var _this2 = this;

        //currently only show the first Item of "footerMap" by default
        var _props = this.props,
            colCount = _props.colCount,
            pageSize = _props.pageSize,
            dataCount = _props.dataCount,
            currentPage = _props.currentPage,
            footerMap = _props.footerMap,
            paginationProps = _props.paginationProps;
        var footerKey = this.state.footerKey;


        return _react2.default.createElement(
            _semanticUiReact.Table.Row,
            null,
            _react2.default.createElement(
                _semanticUiReact.Table.HeaderCell,
                { colSpan: 1 },
                _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                        _semanticUiReact.Label,
                        { color: 'purple', ribbon: true },
                        'Page Size:'
                    ),
                    _react2.default.createElement(_semanticUiReact.Dropdown, { upward: true, floating: true, inline: true,
                        options: pageOptions,
                        defaultValue: pageSize,
                        name: "pageSize",
                        onChange: this.handlePageSizeChange
                    })
                )
            ),
            _react2.default.createElement(
                _semanticUiReact.Table.HeaderCell,
                { key: footerKey, colSpan: colCount - 1 <= 0 ? 1 : colCount - 1 },
                footerMap.map(function (elm, j) {

                    return elm;
                }),
                _react2.default.createElement(_TablePagination2.default, {
                    currentPage: currentPage,
                    totalPages: Math.ceil((dataCount === undefined ? 1 : dataCount) / pageSize),
                    getActivePages: function getActivePages(val) {
                        return _this2.handlePageClick(val);
                    },
                    paginationProps: paginationProps
                })
            )
        );
    };

    return PaginationFooter;
}(_react.Component);

// Secondary do not have page size selection label


PaginationFooter.propTypes = process.env.NODE_ENV !== "production" ? {
    colCount: _propTypes2.default.number.isRequired,
    pageSize: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]).isRequired,
    handlePageClick: _propTypes2.default.func.isRequired,
    dataCount: _propTypes2.default.number.isRequired,
    currentPage: _propTypes2.default.number.isRequired,
    onPageSizeChange: _propTypes2.default.func.isRequired,
    footerMap: _propTypes2.default.array,
    paginationProps: _propTypes2.default.object
} : {};

var PaginationFooterSecondary = exports.PaginationFooterSecondary = function (_Component2) {
    _inherits(PaginationFooterSecondary, _Component2);

    function PaginationFooterSecondary() {
        var _temp, _this3, _ret;

        _classCallCheck(this, PaginationFooterSecondary);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this3 = _possibleConstructorReturn(this, _Component2.call.apply(_Component2, [this].concat(args))), _this3), _this3.state = {
            footerKey: (0, _ObjectsUtils.getRandomNumber)()
        }, _temp), _possibleConstructorReturn(_this3, _ret);
    }

    PaginationFooterSecondary.prototype.handlePageClick = function handlePageClick(val) {
        this.props.handlePageClick(val);
    };

    PaginationFooterSecondary.prototype.render = function render() {
        var _this4 = this;

        //currently only show the first Item of "footerMap" by default
        var _props2 = this.props,
            colCount = _props2.colCount,
            pageSize = _props2.pageSize,
            dataCount = _props2.dataCount,
            currentPage = _props2.currentPage,
            footerMap = _props2.footerMap,
            paginationProps = _props2.paginationProps;
        var footerKey = this.state.footerKey;


        return _react2.default.createElement(
            _semanticUiReact.Table.Row,
            null,
            _react2.default.createElement(
                _semanticUiReact.Table.HeaderCell,
                { key: footerKey, colSpan: colCount },
                footerMap.map(function (elm, j) {

                    return elm;
                }),
                _react2.default.createElement(_TablePagination2.default, {
                    currentPage: currentPage,
                    totalPages: Math.ceil((dataCount === undefined ? 1 : dataCount) / pageSize),
                    getActivePages: function getActivePages(val) {
                        return _this4.handlePageClick(val);
                    },
                    paginationProps: paginationProps
                })
            )
        );
    };

    return PaginationFooterSecondary;
}(_react.Component);

//CustomizedFooter


PaginationFooterSecondary.propTypes = process.env.NODE_ENV !== "production" ? {
    colCount: _propTypes2.default.number.isRequired,
    pageSize: _propTypes2.default.number.isRequired,
    handlePageClick: _propTypes2.default.func.isRequired,
    dataCount: _propTypes2.default.number.isRequired,
    currentPage: _propTypes2.default.number.isRequired,
    footerMap: _propTypes2.default.array,
    paginationProps: _propTypes2.default.object
} : {};
var CustomizedFooter = exports.CustomizedFooter = (_temp2 = _class3 = function (_Component3) {
    _inherits(CustomizedFooter, _Component3);

    function CustomizedFooter(props) {
        _classCallCheck(this, CustomizedFooter);

        var _this5 = _possibleConstructorReturn(this, _Component3.call(this, props));

        _this5.state = {};
        return _this5;
    }

    CustomizedFooter.prototype.render = function render() {

        return _react2.default.createElement('div', null);
    };

    return CustomizedFooter;
}(_react.Component), _class3.defaultProps = {
    tableElementType: "CustomizedFooter"
}, _temp2);
CustomizedFooter.propTypes = process.env.NODE_ENV !== "production" ? {} : {};

var NoPaginationUserFooter = exports.NoPaginationUserFooter = function (_Component4) {
    _inherits(NoPaginationUserFooter, _Component4);

    function NoPaginationUserFooter() {
        var _temp3, _this6, _ret2;

        _classCallCheck(this, NoPaginationUserFooter);

        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
        }

        return _ret2 = (_temp3 = (_this6 = _possibleConstructorReturn(this, _Component4.call.apply(_Component4, [this].concat(args))), _this6), _this6.state = {}, _temp3), _possibleConstructorReturn(_this6, _ret2);
    }

    NoPaginationUserFooter.prototype.render = function render() {
        var _props3 = this.props,
            colCount = _props3.colCount,
            footerMap = _props3.footerMap;


        return _react2.default.createElement(
            _semanticUiReact.Table.Row,
            null,
            _react2.default.createElement(
                _semanticUiReact.Table.HeaderCell,
                { colSpan: colCount },
                footerMap.map(function (elm, j) {

                    return elm;
                })
            )
        );
    };

    return NoPaginationUserFooter;
}(_react.Component);

NoPaginationUserFooter.propTypes = process.env.NODE_ENV !== "production" ? {
    colCount: _propTypes2.default.number.isRequired,
    footerMap: _propTypes2.default.array
} : {};